<?php
/*
 * 
 */
?>
<!DOCTYPE html>
<html>
    <head>
        <title>admin html</title>
        <style>
            .OSrequi:after{content: '*'; color: red;} .OSMadminDetail{font-style: italic;} .OSMadminDetail p span{font-weight: bold;}/* #wpt_selMap{display: none;}*/
 .ewMsgGreen{
    border-left: 4px solid #1e2b02;
    padding: 12px;
    margin: auto;
    background-color: #fff;
    box-shadow: 0 1px 1px 0 rgba(0,0,0,.1);
}
        </style>
    </head>
    <body>
    <div class="wrap">    
        <h1>OSMaps Settings</h1>

        <div class="option-page-wrap">
            <h2 class="nav-tab-wrapper">
                <a class="nav-tab" id="wpt_allMaps_tab" href="#wpt-allMaps">All Maps</a>
                <a class="nav-tab" id="wpt_selMap_tab" href="#wpt-selMap">Selected map</a>
            </h2>

            <form id="useless_form" action=""></form>

            <form action="#" method="post" id="osmaps_form">

                     <!--settings_fields( $OSM->name );-->

                <div class="tab-content-wrapper">
                    <input id="Ser2Bro" name="{$OSM->name}" type="hidden" value='27'>
                    <input id="ShortDefault" type="hidden" value="var">

                    <section id="wpt_allMaps" class="tab-content">
                        <h3 class="wp-heading-inline">Mappe disponibili</h3>
                        <details id="OSMaddMap" class="OSMadminDetail">
                          <summary>Add One Map</summary>
                          <p>
                              <label class="newMapLabel" for="new_map">Name Map</label>
                              <input type="text" id="new_map" title="Your new map. Es: MyNewMap" form="useless_form" pattern="^[a-zA-Z0-9_]*$">
                              <input type="submit" form="useless_form" value="Add new Map">
                          </p>
                        </details>                     
                        <div id="add_del_warning" class="osmMsgGreen">
                            <p><strong>Important. Click Save Changes for a definitive registration.</strong></p>
                        </div>
                        <table class="wp-list-table widefat">
                            <thead>
                                <tr>
                                <td id="cb" class="manage-column">
                                    <label class="screen-reader-text">Seleziona</label>
                                </td>
                                <th scope="col" id="name" class="manage-column column-name">Mappa</th>
                                <th scope="col" id="delete" class="manage-column column-delete">Delete</th>
                                <th scope="col" id="shCode" class="manage-column column-shortcode">ShortCode</th>
                                </tr>
                            </thead>
                            <tbody id="the-list">
                                <tr>
                                    <th scope="row" class="check-column">
                                        <label class="screen-reader-text">Seleziona una mappa</label>
                                        <input type="checkbox" id="mapDefault" data-id="mapDefault" checked onclick="OSMx.clickCheckbox(this);">
                                    </th>
                                    <td class="mapName column-mapName">
                                        <strong>mapDefault</strong>
                                    </td>
                                    <td class="mapDelete column-mapDelete">
                                        <strong> --- </strong>
                                    </td>
                                    <td class="mapShCode column-mapShCode">
                                        <strong>ShortCode</strong>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </section>

                    <section id="wpt_selMap" class="tab-content">
                        <h3 class="wp-heading-inline">Mappa selezionata<span id="osm_selected"></span></h3>
                        <details class="OSMadminDetail">
                            <p> <span>- Longitude</span>. A positive or negative floating point number. Ex. 10.36581 </p>
                            <p> <span>- Latitude</span>. A positive or negative floating point number. Ex. 45.3980 </p>
                            <p> <span>- Help</span>. <a href="https://wpd.edilweb.eu/maps_findCoordinates/" target="_blank"> Help for coordinates </a></p>
                            <p> <span>- Zoom</span>. A positive integer number. Ex. 16</p>
                            <p> <span>- PopUp</span>. Your message. In plain text or text/html format.<br>  &nbsp;Caution. Your html tags could take an existing style from the theme.</p>
                            <p> <span>- Height</span>. Format #px. Ex. 400px </p>
                            <p> <span>- Max-width</span>. Optional. An empty setting will make the image full width. Format #px. Ex. 360px</p>
                        </details> 
                        <table class="form-table">
                            <tbody>
                                <tr>
                                    <th scope="row">
                                        <p><label class="OSrequi" for="longi_tude">Longitude </label></p>
                                    </th>
                                    <td>
                                        <input type="text"  id="longi_tude" class="groupElementschange" pattern="[-+]?([0-9]*\.[0-9]+|[0-9]+)" title="longitude" required>
                                    </td>
                                </tr>
                                <tr>
                                    <th scope="row">
                                        <p><label class="OSrequi" for="lati_tude">Latitude </label></p>
                                    </th>
                                    <td>
                                        <input type="text"  id="lati_tude" class="groupElementschange" pattern="[-+]?([0-9]*\.[0-9]+|[0-9]+)" title="latitude" required>
                                    </td>
                                </tr>
                                <tr>
                                    <th scope="row">
                                        <p><label class="OSrequi" for="zo_om">Zoom</label></p> 
                                    </th>
                                    <td>
                                        <input type="number"  id="zo_om" class="groupElementschange" title="number" min="1" required>
                                    </td>
                                </tr>
                                <tr>
                                    <th scope="row">
                                        <p><label for="mp_type">Map type</label></p>
                                    </th>
                                    <td>
                                        <select id="mp_type" class="groupElementschange">
                                            <option value="1">Simple</option>
                                            <option value="2">with Marker</option>
                                            <option value="3">with PopUp</option>
                                            <option value="5">with Marker and Popup </option>
                                        </select>
                                    </td>
                                </tr>
                                <tr id="hid_tr">
                                    <th scope="row">
                                        <p><label for="map_popup">Your<br> PopUp</label></p>
                                    </th>
                                    <td>
                                        <textarea  id="map_popup" class="mappaPopup groupElementschange"></textarea>
                                        <br><i>HTML allowed</i>
                                    </td>
                                </tr>
                                <tr><th scope="row">CSS</th><td>&nbsp;</td></tr>
                                <tr>
                                    <th scope="row">
                                        <p><label class="OSrequi" for="al_tezza">Height</label></p>
                                    </th>
                                    <td>
                                        <input type="text" id="al_tezza" class="groupElementschange" pattern="^\d{1,4}(px)$" title="title_alt"  value="350px" required>
                                    </td>               
                                </tr>
                                <tr>
                                    <th scope="row">
                                        <p><label for="max_wtd">Max-width </label>
                                    </th>
                                    <td>
                                        <input type="text"  id="max_wtd" class="groupElementschange" pattern="^\d{1,4}(px)$" title="title_max" value="">                                
                                    </td>
                                </tr>
                                <tr>
                                    <th scope="row">
                                        <p><label for="no_wheel">Disable wheel</label></p>
                                    </th>
                                    <td>
                                        <input type="checkbox"  id="no_wheel" class="groupElementschange" title="Disable wheel by default" checked> 
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </section>
                </div>
                <!--submit_button();-->
                <p><input type="submit"></p>
            </form>
        </div>
        <p>&nbsp;</p>
        
        <script>
        (function(){
            var a = mp_type.options[mp_type.selectedIndex].value;
            switch ( a ){
                case '1':
                case '2':
                    map_popup.disabled = true;
                    hid_tr.style.visibility = 'hidden';
                    break;
                case '3':
                case '4':
                case '5':
                    map_popup.disabled = false;
                    hid_tr.style.visibility = 'visible';
                    break;
                default:
                    alert( 'error #5: unknown error in popup' );
                    break;
            }
        })();

        var passiveSupported = false;
        try {
            var options = {
                get passive() { 
                    passiveSupported = true;
                }
            };
            window.addEventListener( "test", options, options );
            window.removeEventListener( "test", options, options );
        } 
        catch( err ) {
            passiveSupported = false;
        }


        mp_type.addEventListener('change',
        function(){
            var a = this.options[this.selectedIndex].value;
            switch ( a ){
                case '1':
                case '2':
                    map_popup.disabled = true;
                    hid_tr.style.visibility = 'hidden';
                    break;
                case '3':
                case '4':
                case '5':
                    map_popup.disabled = false;
                    hid_tr.style.visibility = 'visible';
                    break;
                default:
                    alert( 'error #6: unknown error in popup' );
                    break;
            }
        }, 
        passiveSupported  ? { passive: true } : false );
        </script>

        <script>
        function OSMsettingsJS(){

            var AllSettings = {};       //  tutte le mappe
            var ActiveMap;              //  mappa selezionata            
            var EditedMap;              //  becomes true if the user has changed the map options
            
            this.edited = function(){return EditedMap = true;};
            
            /* display first section, all maps */
            this.displayAll = function(){
                if( EditedMap ){SaveOptionsChanged();}
                wpt_selMap.style.display = 'none';
                wpt_allMaps.style.display = 'block'; console.log('ActiveMap = '+ ActiveMap);
            };
            
            /* click on displayAll prompts you to save the changed options */ 
            function SaveOptionsChanged(){
                AllSettings[ActiveMap].longitude = longi_tude.value;
                AllSettings[ActiveMap].latitude = lati_tude.value;
                AllSettings[ActiveMap].zoom = zo_om.value;
                
                AllSettings[ActiveMap].mptype = mp_type.options[mp_type.selectedIndex].value;

                AllSettings[ActiveMap].mapopup = map_popup.value;
                AllSettings[ActiveMap].height = al_tezza.value;
                AllSettings[ActiveMap].maxwtd = max_wtd.value;
                AllSettings[ActiveMap].noWheel = no_wheel.checked;
                EditedMap = false;                      alert('AllSettis[ActiveMap] = '+AllSettings[ActiveMap]);
            }
            
            /* display second section, options for selected map */
            this.displaySel = function(){
                wpt_allMaps.style.display = 'none';
                wpt_selMap.style.display = 'block';
                ValueSelected();
            };                

            /* sets the active map, the initial default one  */
            /* reads the data of all maps sent by the server */
            /* populates the first section. id="wpt_allMaps" */
            this.ParseSettings = function(){
                /* parse settings   */
//                AllSettings = JSON.parse(window.atob(Ser2Bro.value));
                 AllSettings = JSON.parse(Ser2Bro.value);
                 
                /* clicked map  */
                ActiveMap = 'mapDefault';
                
                /* MapsKey = Array(5) 0: "version" 1: "mapDefault" 2: "pippo_pluto" 3: "ColBeretta" 4: "nonnapapera" length: 5 */
                var MapsKey = Object.keys(AllSettings);
                MapsKey.forEach( function(item){
                    if(item === 'version') {return;}
                    if(item === 'mapDefault') {return;}
                    console.log(item);                        console.log(AllSettings[item].longitude);
                    
                    /* new html row */
                    var genit = document.getElementById('the-list'), riga = document.createElement('tr');
                    riga.id = 'r_' + item;
                    riga.innerHTML = 
                        '<th scope="row" class="check-column">'  +
                            '<label class="screen-reader-text">Seleziona una mappa</label>' +
                            '<input type="checkbox" id="' + item + '" data-id="'+ item +'" onclick="OSMx.clickCheckbox(this);">' +
                        '</th>' +
                        '<td class="mapName column-mapName">' +
                            '<strong>' + item + '</strong>'+
                        '</td>'+
                        '<td class="mapDelete column-mapDelete">'+
                            '<strong><a id="a_' + item + '" href="" onclick="OSMx.deleteMap(this);">Delete</a></strong>'+
                        '</td>'+
                        '<td class="mapShCode column-mapShCode">'+
                            '<strong>['+ ShortDefault.value + '&nbsp;id=' + '"'+ item + '"' + ']</strong>'+
                        '</td>';
                    genit.appendChild(riga);
                });
            };
            
            /* read the last map if edited and prepare the data before sending the form */
            /* id="Ser2Bro" is the only input with a name attribute                        */
            this.MySubmitForm = function(){
                if( EditedMap === true){
                    AllSettings[ActiveMap].longitude = longi_tude.value;
                    AllSettings[ActiveMap].latitude = lati_tude.value;
                    AllSettings[ActiveMap].zoom = zo_om.value;

                    AllSettings[ActiveMap].mptype = mp_type.options[mp_type.selectedIndex].value;

                    AllSettings[ActiveMap].mapopup = map_popup.value;
                    AllSettings[ActiveMap].height = al_tezza.value;
                    AllSettings[ActiveMap].maxwtd = max_wtd.value;

                    AllSettings[ActiveMap].noWheel = no_wheel.checked; 
                }
            /*  prepare string of all settings for server   */
//                Ser2Bro.value = window.btoa(JSON.stringify(AllSettings)); 
                Ser2Bro.value = JSON.stringify(AllSettings);
            };            
            

            /* add a new map to AllSettings variable            */
            /* sets the initial options of the new map          */
            /* adds a new row to the table in the first section */
            /* select the new map                               */
            this.AddNewMap = function(event){
                event.preventDefault();
                if(new_map.value === ''){
                    alert('No Map!'); 
                    return;
                }
                /* double map name error    */
                var MapsKey = Object.keys(AllSettings); 
                var nameError;
                MapsKey.forEach(function(item){
                    if(item === new_map.value){
                        nameError = 1;
                        alert('double map name error !');                            
                    }                    
                });
                if(nameError === 1) {return;}

                /* new map */
                newMap = {
                    longitude: 0,
                    latitude: 0,
                    zoom: 18,
                    mptype: 1,
                    mapopup: '',
                    height: '350px',
                    maxwtd: '',
                    noWheel: 'checked'
                };
                AllSettings[new_map.value] = newMap;                    console.log(Object.keys(AllSettings));

                /* new html row */
                var genit = document.getElementById('the-list'), riga = document.createElement('tr');
                riga.id = 'r_' + new_map.value;
                riga.innerHTML = 
                    '<th scope="row" class="check-column">'  +
                        '<label class="screen-reader-text">Seleziona una mappa</label>' +
                        '<input type="checkbox" id="' + new_map.value + '" data-id="'+ new_map.value +'" onclick="OSMx.clickCheckbox(this);">' +
                    '</th>' +
                    '<td class="mapName column-mapName">' +
                        '<strong>' + new_map.value + '</strong>'+
                    '</td>'+
                    '<td class="mapDelete column-mapDelete">'+
                        '<strong><a id="a_' + new_map.value + '" href="" onclick="OSMx.deleteMap(this);">Delete</a></strong>'+
                    '</td>'+
                    '<td class="mapShCode column-mapShCode">'+
                        '<strong>['+ ShortDefault.value + '&nbsp;id=' + '"'+ new_map.value + '"' + ']</strong>'+
                    '</td>';
                genit.appendChild(riga);

                /* new map checked */
                var cBox = document.querySelectorAll('[data-id]');
                cBox.forEach( function(item){
                    if(item.id === new_map.value){
                        item.checked = true;
                        ActiveMap = item.id;
                        ValueSelected();
                    }
                    else {
                        item.checked = false;
                    }
                });

                /* close detail */
                new_map.value = '';
                OSMaddMap.removeAttribute("open");
                add_del_warning.style = "visibility:visible";
            };
            

            /* the user selects a map  */
             this.clickCheckbox = function(box){
                if(box.id === ActiveMap){
                    event.preventDefault();
                }
                else {
                    document.getElementById(ActiveMap).checked = false; 
                    ActiveMap = box.id;
                    box.checked = true;
                    ValueSelected();
                }
            };
            
            
            this.deleteMap = function(box){
                event.preventDefault();
                let mapToDelete = box.id.substring(2);                  console.log(mapToDelete);
                var dlt = confirm('Delete map '+ mapToDelete + ' Are you sure?');
                if(dlt === false){return;}
                
                document.getElementById(ActiveMap).checked = false;                
                delete AllSettings[mapToDelete];                        console.log(Object.keys(AllSettings));
                document.getElementById('r_' + mapToDelete).style.display = 'none';
                document.getElementById('r_' + mapToDelete).remove();
                ActiveMap = 'mapDefault';
                document.getElementById(ActiveMap).checked = true;
                ValueSelected();
                add_del_warning.style = "visibility:visible";
            };

            /* display options for selected map */
            function ValueSelected (){
                osm_selected.innerHTML = ActiveMap;

                longi_tude.value = AllSettings[ActiveMap].longitude;
                lati_tude.value = AllSettings[ActiveMap].latitude;
                zo_om.value = AllSettings[ActiveMap].zoom;

                for(var i=0; i < mp_type.options.length; i++){
                    if(mp_type.options[i].value === AllSettings[ActiveMap].mptype.toString()) { 
                        mp_type.options[i].selected = true;
                        mapTypeTextarea(mp_type);
                    }
                }

                map_popup.value = AllSettings[ActiveMap].mapopup;
                al_tezza.value = AllSettings[ActiveMap].height;
                max_wtd.value = AllSettings[ActiveMap].maxwtd;
                no_wheel.checked = AllSettings[ActiveMap].noWheel;
            }

            /* display map popup for input text. Optional */
            function mapTypeTextarea(cheType){
                var a = cheType.options[cheType.selectedIndex].value;
                switch ( a ){
                    case '1':
                    case '2':
                        map_popup.disabled = true;
                        hid_tr.style.visibility = 'hidden';
                        break;
                    case '3':
                    case '4':
                    case '5':
                        map_popup.disabled = false;
                        hid_tr.style.visibility = 'visible';
                        break;
                    default:
                        alert( 'error #6: unknown error in popup' );
                        break;
                }
            }

        }

var OSMx = new OSMsettingsJS;
        
document.addEventListener('DOMContentLoaded', ()=>{
        OSMx.ParseSettings();

        wpt_allMaps_tab.addEventListener('click', function(){
            OSMx.displayAll();
        });

        wpt_selMap_tab.addEventListener('click', function(){
            OSMx.displaySel();
        });

        osmaps_form.addEventListener('submit', function(){
            OSMx.MySubmitForm();
        });

        useless_form.addEventListener('submit', function(event){
            OSMx.AddNewMap(event);
        });
        
        document.querySelectorAll('.groupElementschange').forEach(item => {            
            item.addEventListener('change', (event)=> {
                OSMx.edited();
            }); 
        });
  });        
/* document.getElementById("my-element").remove();*/

/* 
* class groupElementschange 
* id="longi_tude"
* id="lati_tude"
* id="zo_om"
* id="mp_type"
* id="map_popup"
* id="al_tezza"
* id="max_wtd"
* id="no_wheel"
 */
        </script>
    </div>
    </body>
</html>